# Importation de tous les modules de la bibliothèque micro:bit
from microbit import *
# Importation du module time (fournit différentes fonctions liées au temps)
import time

# Définition de la fonction déclenchant l'émission d'une salve et la mesure de la durée du parcours
def duree_parcours_us(pin, timeout = 1000000):
    pin.write_digital(0)
    time.sleep_us(2)
    pin.write_digital(1)
    time.sleep_us(5)
    pin.write_digital(0)
    t_init = time.ticks_us()
    while (pin.read_digital() != 1):
        if(time.ticks_us() - t_init > timeout):
            return 0
    start = time.ticks_us()   # Date d'émission de la salve US
    while (pin.read_digital() == 1):
        if(time.ticks_us() - t_init > timeout):
            return 0
    end = time.ticks_us()     # Date de réception de la salve US
    return end - start        # La fonction retourne la durée du parcours de la salve

# Bloc d'instructions à exécuter en boucle
while True:
    # Invite pour appuyer sur le bouton A
    while not button_a.was_pressed():
        display.show(Image.ARROW_W)
    # Si le bouton A est pressé, lancement de la mesure et affichage de la durée de parcours
    duree = duree_parcours_us(pin0)
    display.show(Image.YES, clear=True)
    print("Duree : {} microsecondes".format(duree))