# Importation de tous les modules de la bibliothÃ¨que micro:bit
from microbit import *
# Importation du module time (fournit diffÃ©rentes fonctions liÃ©es au temps)
import time


# DÃ©finition de la fonction permettant de gÃ©nÃ©rer un son avec le buzzer
def beep (pin, noteFrequency, noteDuration, sleepDuration = 100):
    microsecondsPerWave = 1e6/noteFrequency
    millisecondsPerCycle = 1000/(microsecondsPerWave * 2)
    loopTime = noteDuration * millisecondsPerCycle
    for x in range(loopTime):
        pin.write_digital(1)
        time.sleep_us(int(microsecondsPerWave))
        pin.write_digital(0)
        time.sleep_us(int(microsecondsPerWave))
    sleep(sleepDuration)


# DÃ©finition de la fonction dÃ©clenchant l'Ã©mission d'une salve et la mesure de la durÃ©e du parcours
def distance_parcours_us(pin, timeout = 1000000):
    pin.write_digital(0)
    time.sleep_us(2)
    pin.write_digital(1)
    time.sleep_us(5)
    pin.write_digital(0)
    t_init = time.ticks_us()
    while (pin.read_digital() != 1):
        if(time.ticks_us() - t_init > timeout):
            return 0
    start = time.ticks_us()   # Date d'Ã©mission de la salve US
    while (pin.read_digital() == 1):
        if(time.ticks_us() - t_init > timeout):
            return 0
    end = time.ticks_us()     # Date de rÃ©ception de la salve US
    distance = 0.5*340*(end-start)*1e-6        # Distance parcourue
    return distance        # La fonction retourne la distance parcourue par la salve


# Bloc d'instructions Ã  exÃ©cuter en boucle
while True:
    # Invite pour appuyer sur le bouton A
    while not button_a.was_pressed():
        display.show(Image.ARROW_W)
    # Si le bouton A est pressÃ©, lancement de la mesure et affichage de la distance parcourue
    dist = distance_parcours_us(pin0)
    display.show(Image.YES, clear=True)
    print("Distance capteur/obstacle : {} m".format(dist))
    if dist < 0.20:
        beep(pin1, 1760, 300)
    elif dist < 0.30:
        beep(pin1, 1320, 500)
    elif dist < 0.40:
        beep(pin1, 880, 700)
    else:
        beep(pin1, 440, 700)